(* Debug *)
(* $Id: debug.ml,v 1.1.1.1 2002/09/02 08:49:25 durak Exp $ *)

type level = Trace of int | Debug of int | Info | Critical | Warning
and category = System | Network | Game | Server | Strategy | Other of string

type 'a wildcard = All | Only of 'a list

let sf = Printf.sprintf

let debug_enabled : (level wildcard * category wildcard) list ref = ref [] (* [Only[Critical],All] *)

let matches x = function
    All -> true
  | Only l -> List.mem x l

let debug (lev,cat) x =
  if List.exists (fun (lw,cw) -> matches lev lw && matches cat cw) !debug_enabled then
	begin
	  Printf.eprintf "%010.0f %c-%s %s\n"
		(Unix.time ())
		(match lev with Debug _ -> 'D' | Info -> 'I' | Critical -> 'C' | Warning -> 'W' | Trace _ -> 'T')
		(match cat with
		  Network -> "netw" | Game -> "game" | Strategy -> "stra" | Server -> "serv"
		| System -> "syst" | Other x -> x)
		x;
	  flush stderr
	end
  else
	()
